Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your LED Strip Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"ls", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletLEDStrip\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Set frame duration to 50ms (20 frames per second)", "*)"}],
   RowBox[{"ls", "@", RowBox[{"SetFrameDuration", "[", "50", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"numLEDs", "=", "16"}],
   RowBox[{"rIndex", "=", "1"}],
   RowBox[{"r", "=", RowBox[{"{", RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}],
   RowBox[{"g", "=", RowBox[{"{", RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}],
   RowBox[{"b", "=", RowBox[{"{", RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Use frame rendered callback to move the active LED every frame", "*)"}],
   RowBox[{RowBox[{"FrameRenderedCB", "[", RowBox[{"sender_", ",", "length_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Module", "[", RowBox[{RowBox[{"{", "}"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"b", "[", RowBox[{"[", "rIndex", "]"}], "]"}], "=", "0", ";", "\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"rIndex", "==", "numLEDs"}], ",", RowBox[{"rIndex", "=", "1"}], ",", RowBox[{"rIndex", "=", "rIndex", "+", "1"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"b", "[", RowBox[{"[", "rIndex", "]"}], "]"}], "=", "255", ";", "\n", "\[IndentingNewLine]", RowBox[{"(*", " Set new data for next render cycle ", "*)"}], "\[IndentingNewLine]", "sender", "@", RowBox[{"SetRGBValues", "[", RowBox[{"0", ",", "numLEDs", ",", "r", ",", "g", ",", "b"}], "]"}], "\[IndentingNewLine]"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"ls", "@", "FrameRenderedCallback"}], ",", "FrameRenderedCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", " Set initial rgb values to get started ", "*)"}],
   RowBox[{"ls", "@", RowBox[{"SetRGBValues", "[", RowBox[{"0", ",", "numLEDs", ",", "r", ",", "g", ",", "b"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "ls", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
