Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your Load Cell Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"lc", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletLoadCell\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Get threshold callbacks with a debounce time of 1 second (1000ms)", "*)"}],
   RowBox[{"lc", "@", RowBox[{"SetDebouncePeriod", "[", "1000", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Callback function for weight reached callback", "*)"}],
   RowBox[{RowBox[{"WeightReachedCB", "[", RowBox[{"sender_", ",", "weight_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Weight: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", RowBox[{"Quantity", "[", RowBox[{"weight", ",", "\"\<g\>\""}], "]"}], "]"}], "]"}]}], "]"}]}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"lc", "@", "WeightReachedCallback"}], ",", "WeightReachedCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Configure threshold for weight ", "\"\<greater than 200 g\>\"", "", "*)"}],
   RowBox[{"option", "=", "Tinkerforge`BrickletLoadCell`THRESHOLDUOPTIONUGREATER"}],
   RowBox[{"lc", "@", RowBox[{"SetWeightCallbackThreshold", "[", RowBox[{"option", ",", "200", ",", "0"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "lc", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
